function [d,y, F2]= copula_new(by1,by2,bd1,bd2,thet,groups)
% the next block creates uniformly random variables on [0,1] that have
% correlation induces by the copula parameter theta
n=250^2;
u = linspace(0,1,n.^.5);
[U1,U2] = meshgrid(u,u);
F2 = copulapdf('Frank',[U1(:) U2(:)],thet);
%rng('default')
R = randsample(linspace(1,n,n),50000000,true,F2');
a1=U1(R);
a2=U2(R);
%a1 and a2 are uniform random variables on zero 1 that have a correlation
%induced by the copula
b2=betainv(a1,by1,by2);
b1=betainv(a2,bd1,bd2);
%b1 and b2 are beta distributed and have a correlation induced by the
%copula

[a, b]=hist3([b1' b2'],[100 100]); % joint density a on grid b
dgrid=b{1,1};
ygrid=b{1,2};

zn=a./sum(a(:)); % proper density
fy=sum(zn,1); %marginal for y
Fy=cumsum(fy); %cumulative for y

% just initalize
fd_y=zeros(100,100);
Fd_y=zeros(100,100);
pindd_y=zeros(groups,1);
pindy=zeros(groups,groups);

pctl=1/groups*.5+1/(groups)*(0:1:groups-1); % creates the percentile grid

for i=1:100
    fd_y(:,i)=(zn(:,i))./fy(i);
    Fd_y(:,i)=cumsum(fd_y(:,i)); %conditional cdf of d for the various values of y 
end

for i=1:groups
    dif=abs(Fy-pctl(i));
    pindd_y(i)=min(find(dif == min(dif))); % grabs the indicator (for y) of the point closest to the respective percentile (will get at most `groups' different value)
for j=1:groups
    dif=abs(Fd_y(:,pindd_y(i))-pctl(j));
    pindy(i,j)=min(find(dif == min(dif)));   % same but conditional on the y grabs (up to) `groups' different values for d
end
end

d=dgrid(pindy(:))'.*((bd1./(bd2+bd1))/mean(dgrid(pindy(:))')); %first part picks the d, second part just corrects for numerical error by adjusting such that mean is "true" mean (small adjustment)
y=repmat(ygrid(pindd_y)', groups, 1).*((by1./(by2+by1))/mean(ygrid(pindd_y)'));
d=d.*(1+normrnd(0,1/1000,size(d)))./10;

