function []= create_fake(cas,Sxv2,w,WU,dn,yn,bet,lam0,lam1,alph,ny,nx,nd,nf,x,up,down,z,rs)

%%%%% This file creates a simulated dataset that can be imported into stata
%%%%% (with file import_fake.do) to run jobloss regressions
rng('default')
N =50000; % new N, 50K FOR PAPER
T2= 36*12 %32*12;
T=T2;

%%
NSim=4

parfor i=1:NSim
%[stat, firm, bench, hc, hcneg,  wage, surplus, wu, firmp, workerp, output, sep, extr, espell, jspell, uspell]=dataset_only_extended(Sxv2,w,WU,dn,yn,bet,lam0,lam1,alph,ny,nx,nd,nf,x,up,down,z,T2,N);
[stat, firm, hc, wage, firmp, workerp, espell, jspell, uspell, bench, hcneg]=dataset_only_extended(Sxv2,w,WU,dn,yn,bet,lam0,lam1,alph,ny,nx,nd,nf,x,up,down,z,T,N,rs);

s_dat(:,:,i)=[stat, firm, wage, espell, jspell, uspell];
end
%%

for i=1:NSim
    stat_dat(:,:,i)=s_dat(:,1:N,i);
    firm_dat(:,:,i)=s_dat(:,N+1:2*N,i);
    wage_dat(:,:,i)=s_dat(:,2*N+1:3*N,i);
    e_dat(:,:,i)=s_dat(:, 3*N+1:4*N,i);
    j_dat(:,:,i)=s_dat(:, 4*N+1:5*N,i);
    u_dat(:,:,i)=s_dat(:, 5*N+1:6*N,i); 
end

%sim_dat2=reshape(sim_dat,T,13*N*NSim);
wd=ceil(wage_dat*1000)/1000;
sd=ceil(stat_dat*1000)/1000;
fd=ceil(firm_dat*1000)/1000;
wsim=reshape(wage_dat,T,N*NSim);
ssim=reshape(stat_dat,T,N*NSim);
fsim=reshape(firm_dat,T,N*NSim);
esim=reshape(e_dat,T,N*NSim);
jsim=reshape(j_dat,T,N*NSim);
usim=reshape(u_dat,T,N*NSim);
%%
id2=repmat(linspace(1,N*NSim,N*NSim),T,1);
id=id2(:);
dat=repmat(linspace(1,T,T)',N*NSim,1);
datsim=[id dat ssim(:) wsim(:) fsim(:) esim(:) jsim(:) usim(:)];
if cas==1
dlmwrite('data_fake.csv', datsim, 'delimiter', '\t', 'precision', 11);
elseif cas==2
dlmwrite('data_fake_het_delta.csv', datsim, 'delimiter', '\t', 'precision', 11);
elseif cas==3
dlmwrite('data_fake_het_s.csv', datsim, 'delimiter', '\t', 'precision', 11);
end