%% This file offers a decomposition of the wage losses from job loss building on counterfactual simulations
rng('default')
%% Generating a dataset
clear sim_dat stat firm bench hc hcneg wage surplus wu
T2=312; %296; 26 years
N=100000; % 100000 for whats in the paper
simdat=[];
NSim =24; % 24 for whats in the paper
stat=[];
firm=[];
bench=[];
hc=[];
hcneg=[];
wage=[];
surplus=[];
wu=[];

for j=1:20 % 100 for whats in the paper
    
    parfor i=1:NSim
     [stat, firm, hc, wage, firmp, workerp, espell, jspell, uspell, bench, hcneg]=dataset_only_extended(Sxv2,w,WU,dn,yn,bet,lam0,lam1,alph,ny,nx,nd,nf,x,up,down,z,T2,N,rs);
     sim_dat(:,:,i)=[stat, firm, bench, hc, hcneg, wage]
    end
    
    stat1=[reshape(sim_dat(:,1:N,:),T2,N*NSim) ];
    firm1=[reshape(sim_dat(:,N+1:2*N,:),T2,N*NSim) ];
    bench1=[reshape(sim_dat(:,2*N+1:3*N,:),T2,N*NSim) ] ;
    hc1=[reshape(sim_dat(:,3*N+1:4*N,:),T2,N*NSim) ];
    hcneg1=[reshape(sim_dat(:,4*N+1:5*N,:),T2,N*NSim) ];
    wage1=[reshape(sim_dat(:,5*N+1:6*N,:),T2,N*NSim) ];
    %surplus1=[reshape(sim_dat(:,6*N+1:7*N,:),T2,N*NSim) ];
    %wu1=[reshape(sim_dat(:,7*N+1:8*N,:),T2,N*NSim) ];
    
    % Select high tenured job losers
    t=tstart;
    t2=1;
    samp1=(sum(stat1(t2:t-2,:))==tstart-2 & stat1(t-1,:)==1 &sum(firm1(t2:t-2,:))./(tstart-2)==firm1(t-2,:));
    samp2=(sum(stat1(t2:t-2,:))==tstart-2 & stat1(t-1,:)==0 &sum(firm1(t2:t-2,:))./(tstart-2)==firm1(t-2,:));% job losers w/ selection criterion
    samp1_ind=logical(samp1);
    samp2_ind=logical(samp2);
    
    stat1=stat1(:,samp2_ind);
    firm1=firm1(:,samp2_ind);
    bench1=bench1(:,samp2_ind);
    hc1=hc1(:,samp2_ind);
    hcneg1=hcneg1(:,samp2_ind);
    wage1=wage1(:,samp2_ind);
    %surplus1=surplus1(:,samp2_ind);
    %wu1=wu1(:,samp2_ind);
    
    stat=[stat stat1];
    firm=[firm firm1];
    bench=[bench bench1] ;
    hc=[hc hc1];
    hcneg=[hcneg hcneg1];
    wage=[wage wage1];
   % surplus=[surplus surplus1];
   % wu=[wu wu1];
    j
end

N2=size(stat,2);

%% This blocks creates random realizations to simulate counterfactuals
fu=(rand(T2,N2)<lam0);
fj=(rand(T2,N2)<lam1);
s=rand(T2,N2);
draw=ceil(rand(T2,N2)*nf);
Sst=Sxv2(:);
WUst=WU(:);
wst=w(:);

%% this block computes counterfactual wages for the treatment group letting everything stochastically evolve assuming job loss did not happen
statcf2=stat;
firmcf2=firm;
benchcf2=bench;
hcnegcf2=hcneg;
hccf2=hc;
up_s=(rand(T2,N2)<up);
down_s=(rand(T2,N2)<down);

for t=tstart-1:T2
    if t==tstart-1
        statcf2(t,:)=ones(1,N2);
    else
        statcf2(t,:)=statcf2(t-1,:).*(1-(s(t,:)<dn(firmcf2(t-1,:))'))+(1-statcf2(t-1,:)).*fu(t,:).*[Sst((hccf2(t-1,:)-1)*nf+draw(t-1,:))>0]';
    end
    hccf2(t,:)=statcf2(t,:).*(up_s(t,:).*min(hccf2(t-1,:)+1,nx)+(1-up_s(t,:)).*hccf2(t-1,:))+...
        (1-statcf2(t,:)).*(down_s(t,:).*max(hccf2(t-1,:)-1,1)+(1-down_s(t,:)).*hccf2(t-1,:));
    
    firmcf2(t,:)=(statcf2(t,:)-statcf2(t-1,:)==1).*draw(t,:)+(statcf2(t,:)==1).*((statcf2(t-1,:)==1)).*...
        (fj(t,:).*(Sxv2(draw(t,:)+(hccf2(t,:)-1)*nf)>Sxv2(firmcf2(t-1,:)+(hccf2(t,:)-1)*nf)).*draw(t,:)+...
        (1-fj(t,:).*(Sxv2(draw(t,:)+(hccf2(t,:)-1)*nf)>Sxv2(firmcf2(t-1,:)+(hccf2(t,:)-1)*nf))).*firmcf2(t-1,:))...
        +(1-statcf2(t,:)).*firmcf2(t-1,:);
    
   reneg=rs((draw(t,:)-1)*nx*nx*nf*(nf+1)+(hccf2(t,:)-1)*nx*nf*(nf+1)+(hcnegcf2(t-1,:)-1)*nf*(nf+1)+(benchcf2(t-1,:))*nf+(firmcf2(t-1,:)))';
   
   benchcf2(t,:)=(statcf2(t,:)-statcf2(t-1,:)==1).*zeros(1,N2)+(1-(statcf2(t,:)==1)).*zeros(1,N2)+...
        (statcf2(t,:)==1).*(statcf2(t-1,:)==1).*...
        (fj(t,:).*(Sxv2(draw(t,:)+(hccf2(t,:)-1)*nf)>Sxv2(firmcf2(t-1,:)+(hccf2(t,:)-1)*nf)).*firmcf2(t-1,:)+...
        fj(t,:).*reneg.*draw(t,:)+...
        ((1-fj(t,:))+fj(t,:).*(1-(Sxv2(draw(t,:)+(hccf2(t,:)-1)*nf)>Sxv2(firmcf2(t-1,:)+(hccf2(t,:)-1)*nf))-reneg)).*benchcf2(t-1,:));    

   hcnegcf2(t,:)=statcf2(t,:).*(((benchcf2(t,:)~=benchcf2(t-1,:)) | ((firmcf2(t,:)~=firmcf2(t-1,:)))).*hccf2(t,:)+...
        +(1-((benchcf2(t,:)~=benchcf2(t-1,:)) | (firmcf2(t,:)~=firmcf2(t-1,:)))).*hcnegcf2(t-1,:))+...
        (1-statcf2(t,:)).*hccf2(t,:);
    
    t;
end

%hcnegcf2=(hcnegcf2>hccf2).*hccf2+(1-(hcnegcf2>hccf2)).*hcnegcf2;
windcount=(hcnegcf2-1)*nf*(nf+1)+(benchcf2)*nf+firmcf2;
wagecount=wst(windcount).*statcf2;

count3=sum(statcf2,2);
w_ns=sum(wagecount,2)./count3;
plot(w_ns)
hold

%% this block keeps the worker in the job but kills the benchmark  employer such that the neg capital stock has to be rebuilt
statcf2_2=stat;
firmcf2_2=firm;
benchcf2_2=bench;
hcnegcf2_2=hcneg;
hccf2_2=hccf2;

for t=tstart-1:T2
    if t==tstart-1
        statcf2_2(t,:)=ones(1,N2);
       
        firmcf2_2(t,:)=(statcf2_2(t,:)-statcf2_2(t-1,:)==1).*draw(t,:)+(statcf2_2(t,:)==1).*((statcf2_2(t-1,:)==1)).*...
            (fj(t,:).*(Sxv2(draw(t,:)+(hccf2(t,:)-1)*nf)>Sxv2(firmcf2_2(t-1,:)+(hccf2(t,:)-1)*nf)).*draw(t,:)+...
            (1-fj(t,:).*(Sxv2(draw(t,:)+(hccf2(t,:)-1)*nf)>Sxv2(firmcf2_2(t-1,:)+(hccf2(t,:)-1)*nf))).*firmcf2_2(t-1,:))...
            +(1-statcf2_2(t,:)).*firmcf2_2(t-1,:);
        
        benchcf2_2(t,:)=zeros(1,N2);
        
        
    else
        
        statcf2_2(t,:)=statcf2_2(t-1,:).*(1-(s(t,:)<dn(firmcf2_2(t-1,:))'))+(1-statcf2_2(t-1,:)).*fu(t,:).*[Sst((hccf2_2(t-1,:)-1)*nf+draw(t-1,:))>0]';
        
        firmcf2_2(t,:)=(statcf2_2(t,:)-statcf2_2(t-1,:)==1).*draw(t,:)+(statcf2_2(t,:)==1).*((statcf2_2(t-1,:)==1)).*...
            (fj(t,:).*(Sxv2(draw(t,:)+(hccf2(t,:)-1)*nf)>Sxv2(firmcf2_2(t-1,:)+(hccf2(t,:)-1)*nf)).*draw(t,:)+...
            (1-fj(t,:).*(Sxv2(draw(t,:)+(hccf2(t,:)-1)*nf)>Sxv2(firmcf2_2(t-1,:)+(hccf2(t,:)-1)*nf))).*firmcf2_2(t-1,:))...
            +(1-statcf2_2(t,:)).*firmcf2_2(t-1,:);
        
        reneg=rs((draw(t,:)-1)*nx*nx*nf*(nf+1)+(hccf2_2(t,:)-1)*nx*nf*(nf+1)+(hcnegcf2_2(t-1,:)-1)*nf*(nf+1)+(benchcf2_2(t-1,:))*nf+(firmcf2_2(t-1,:)))';
        
        benchcf2_2(t,:)=(statcf2_2(t,:)-statcf2_2(t-1,:)==1).*zeros(1,N2)+(1-(statcf2_2(t,:)==1)).*zeros(1,N2)+...
        (statcf2_2(t,:)==1).*(statcf2_2(t-1,:)==1).*...
        (fj(t,:).*(Sxv2(draw(t,:)+(hccf2_2(t,:)-1)*nf)>Sxv2(firmcf2_2(t-1,:)+(hccf2_2(t,:)-1)*nf)).*firmcf2_2(t-1,:)+...
        fj(t,:).*reneg.*draw(t,:)+...
        ((1-fj(t,:))+fj(t,:).*(1-(Sxv2(draw(t,:)+(hccf2_2(t,:)-1)*nf)>Sxv2(firmcf2_2(t-1,:)+(hccf2_2(t,:)-1)*nf))-reneg)).*benchcf2_2(t-1,:));    

        hcnegcf2_2(t,:)=statcf2_2(t,:).*(((benchcf2_2(t,:)~=benchcf2_2(t-1,:)) | ((firmcf2_2(t,:)~=firmcf2_2(t-1,:)))).*hccf2_2(t,:)+...
        +(1-((benchcf2_2(t,:)~=benchcf2_2(t-1,:)) | (firmcf2_2(t,:)~=firmcf2_2(t-1,:)))).*hcnegcf2_2(t-1,:))+...
        (1-statcf2_2(t,:)).*hccf2_2(t,:);
        
        t;
    end
end

%hcnegcf2_2=hcnegcf2;
%hcnegcf2_2=(hcnegcf2_2>hccf2).*hccf2+(1-(hcnegcf2_2>hccf2)).*hcnegcf2_2;

windcount2_2=(hcnegcf2_2-1)*nf*(nf+1)+(benchcf2_2)*nf+firmcf2_2;
wagecount2_2=wst(windcount2_2).*statcf2_2;

count32_2=sum(statcf2_2,2);
w_nb=sum(wagecount2_2,2)./count32_2;
plot(w_nb)

%% this block fires the worker but keeps her human capital fixed
firmcf_2=firm;
benchcf_2=bench;
statcf_2=stat;
hcnegcf_2=hcnegcf2;
hccf_2=hccf2;

windcount_2=(hcnegcf_2-1)*nf*(nf+1)+(benchcf_2)*nf+firmcf_2;
wagecount_2=wst(windcount_2).*statcf_2;

count3_2=sum(statcf_2,2);
w_nj=sum(wagecount_2,2)./count3_2;
plot(w_nj)

%% this block computes wages for job_losers
wa=(wage./wage.*wage); %eliminate zeros
w_jl=nanmean(wa,2);
plot(w_jl,'y')

%%

series3_2=w_nj./w_ns
series2_2=w_nb./w_ns
series4=w_jl./w_ns
series1=w_ns./w_ns

series1=[series1(1:60)' smooth(series1(61:end))']'
series3_2=[series3_2(1:60)' smooth(series3_2(61:end))']'
series2_2=[series2_2(1:60)' smooth(series2_2(61:end))']'
series2_2(35)=1
series3_2(35)=1
series4=[series4(1:60)' smooth(series4(61:end))']'
oneone=ones(1,T2);
t=linspace(-35,T2-36,T2);
X=[t,fliplr(t)];
Y2_2=[series1',fliplr(series2_2')];
Y3_2=[series2_2',fliplr(series3_2')];
series3_2(35)=series4(34);
series4(35)=series4(34)
Y4_2=[series3_2',fliplr(series4')];
for tt=2:size(Y4_2,2)
    if isnan(Y3_2(tt))==1
        Y3_2(tt)=Y3_2(tt-1)
    end
    if isnan(Y4_2(tt))==1
        Y4_2(tt)=Y4_2(tt-1)*isnan(Y4_2(tt));
    end
end


close all

save decomposition X Y2_2 Y3_2 Y4_2 series4 series1
%%
load decomposition

T2=312;
t=linspace(-35,T2-36,T2);

figure(2)
plot(t,(series4./series1),'b', t, series1./series1,'k');
leg=legend('Wage','Location','SouthEast')
tit=title('Decomposing Wage Losses')
xh=xlabel('Months Before and after Separation')
yh=ylabel('Wage rel. to Counterfactual')
set([xh,yh,tit,leg],'fontweight','bold','fontsize',15);
%set([xh,yh,leg],'fontweight','bold','fontsize',15);
axis([-40 265 .8 1.01])
print -depsc2 decomposition_2_2.eps

true_w_loss=series4./series1;
save true_w_loss true_w_loss

figure(3)
fill(X,Y2_2,'r');
hold
plot(t,series4,t, series1./series1,'k');
leg=legend('Negotiation Capital','Location','SouthEast')
tit=title('Decomposing Wage Losses')
xh=xlabel('Months Before and after Separation')
yh=ylabel('Wage rel. to Counterfactual')
set([xh,yh,tit,leg],'fontweight','bold','fontsize',15);
axis([-40 265 .8 1.01])
print -depsc2 decomposition_3_2.eps
hold off

figure(4)
fill(X,Y3_2,'b',X,Y2_2,'r');
hold on
plot(t,series4,t, series1./series1,'k');
leg=legend('Negotiation Capital','Employer Capital','Location','SouthEast')
tit=title('Decomposing Wage Losses')
xh=xlabel('Months Before and after Separation')
yh=ylabel('Wage rel. to Counterfactual')
set([xh,yh,tit,leg],'fontweight','bold','fontsize',15);
axis([-40 265 .8 1.01])
print -depsc2 decomposition_4_2.eps
hold off

X2=[linspace(0,20,21) linspace(20,0,21)]

figure(5)
%fill(X,Y2_2,'r',X,Y3_2,'b',X,Y4_2,'g',X2,[Y4_2(36:56) Y4_2(end-56:end-36)],[0.3 0.9 .21])
fill(X,Y2_2,'r',X,Y3_2,'b',X,Y4_2,'g')
hold on
plot(t,series4,'k', 'LineWidth',3);
leg=legend('Negotiation Rents','Firms','Human Capital','Location','SouthEast')
tit=title('Decomposing Wage Losses')
xh=xlabel('Months Before and after Separation')
yh=ylabel('Wage rel. to Counterfactual')
set([xh,yh,tit,leg],'fontweight','bold','fontsize',15);
axis([-40 265 .8 1.01])
print -depsc2 decomposition_5_2.eps


