% Import data from text file
% Script for importing data from the following text file:
%
%    filename: C:\Users\gjarosch\Dropbox\JMP\German Data\Test_Data_Revision\log\losses_ext.txt
%
% Auto-generated by MATLAB on 30-Jun-2020 05:14:30

%% Setup the Import Options and import the data
opts = delimitedTextImportOptions("NumVariables", 10);

% Specify range and delimiter
opts.DataLines = [2, Inf];
opts.Delimiter = "\t";

% Specify column names and types
opts.VariableNames = ["VarName2", "LE_FE1", "LE_FEE1", "LE_Q10", "LE_Q1", "LE_Q50", "LE_Q2", "LE_Q90", "VarName10"];
opts.VariableTypes = ["double", "double", "double", "double", "double", "double", "double", "double", "string"];

% Specify file level properties
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";

% Specify variable properties
opts = setvaropts(opts, "VarName10", "WhitespaceRule", "preserve");
opts = setvaropts(opts, "VarName10", "EmptyFieldRule", "auto");
opts = setvaropts(opts, "VarName2", "TrimNonNumeric", true);
opts = setvaropts(opts, "VarName2", "ThousandsSeparator", ",");

% Import the data
tbl = readtable("C:\Users\gjarosch\Dropbox\JMP\German Data\Test_Data_Revision\log\losses_ext_final.txt", opts);

%% Convert to output type
VarName2 = tbl.VarName2;
LE_FE_mod = tbl.LE_FE1;
LE_FEE1_mod = tbl.LE_FEE1;
LE_Q10_mod = tbl.LE_Q10;
LE_Q25_mod = tbl.LE_Q1;
LE_Q50_mod = tbl.LE_Q50;
LE_Q75_mod = tbl.LE_Q2;
LE_Q90_mod = tbl.LE_Q90;
VarName10 = tbl.VarName10;

%% Clear temporary variables
clear opts tbl

matname=strcat('res_ext')
save(matname,'LE_FE_mod','LE_FEE1_mod','LE_Q10_mod','LE_Q25_mod','LE_Q50_mod','LE_Q75_mod','LE_Q90_mod')
