%% this file constructs the indiffifference curve figure

close all

% just some useful matrices
for i=1:nx
if i==nx 
    up_matrix(i,i)=1;
    up_matrix2(i,i)=0;
else 
    up_matrix(i,i)=1-up; 
    up_matrix(i,i+1)=up;
    up_matrix2(i,i)=-1; 
    up_matrix2(i,i+1)=1;
end 
end

for i=1:nx
    if i==1 
        down_matrix(i,i)=1; 
    else
        down_matrix(i,i)=1-down;
        down_matrix(i,i-1)=down;
    end
end

inv_matrix=inv(eye(nx)-bet*down_matrix);

%% Equilibrium and Planner Surplus Functions (Planner corresponds to \alpha=1)
cas=1;
for alph_e=[.5,1]
[S2,wxx,WUxx,rsxx]= values_full_with_u(dn,yn,bet,lam0,lam1,alph_e,nx,nf,x,up,down,z,by1,by2,bd1,bd2,thet,ymin);
S2_eb(:,:,cas)=S2;
cas=cas+1;
end
%% search for the y that compensates for some increase in delta so as to get points on the indifference curves
cas=1
for alph_e=[.5,1]
   
S2_e=S2_eb(:,:,cas);

% pick a worker human capital
kk=10;

jjob=1;
for jj=[80,91] % pick some job
    
aS=1/nf*(sum(S2_e)); 
U=inv_matrix*(z+bet*down_matrix*lam0*alph_e*aS');

S_sam=S2_e(jj,:);

qc=1;
%perturb delta
for dd=[.005, .01, .02, .05, .1, .115 ];

yy=yn(jj)*dd/dn(jj);

dis2=10;
while (abs(dis2)>10^-9)
dis=10;
% the next block solves for the surplus of the proposed \delta,y pair. Need
% to solve for all human capital because it's stochastic
while (abs(dis)>10^-8)
    for i=nx:-1:1
        S_sam2(i)=x(i)+bet*(up_matrix(i,:)-down_matrix(i,:))*U+yy-z+bet*((1-up)*((1-dd).*...
            (S_sam(i)+lam1*alph_e*sum(max(S2_e(:,i)-S_sam(i),0))./nf))+...
            up*((1-dd).*...
            (S_sam(min(i+1,nx))+lam1*alph_e*sum(max(S2_e(:,min(i+1,nx))-S_sam(min(i+1,nx)),0))./nf)))-bet*((1-down)*lam0*alph_e*aS(i)+down*lam0*alph_e*aS(max(i-1,1)));
    end
    dis=sum(sum(abs(S_sam2-S_sam)));
    S_sam=S_sam2;
end
% now update the y: if surplus of propsed pair lied above indifference
% curve then reduce
yy=yy-(abs(yy)+.001)*(S_sam(kk)-S2_e(jj,kk))/(5*S2_e(jj,kk));
dis2=abs(S_sam(kk)-S2_e(jj,kk));
end
%save the points qc for jobs jjob and planner/equil cas
yy_d(qc,jjob,cas)=yy;
dd_d(qc,jjob,cas)=dd;
qc=qc+1;
end
jjob=jjob+1;
end
cas=cas+1;
end

%% finding the reservation productivity

eps0=0.001;
S_sam=S2_e(jj,:);

d0grid=[.005, .01, .02, .05, .1, .115 ];

cas=1;
for alph_e=[.5,1]
    
qc=1;
%perturb delta
for dd=d0grid
yy=-.7;

dis2=10;
while (abs(dis2)>10^-6)
dis=10;
% the next block solves for the surplus of the proposed \delta,y pair. Need
% to solve for all human capital because it's stochastic
while (abs(dis)>10^-8)
    for i=nx:-1:1
        S_sam2(i)=x(i)+bet*(up_matrix(i,:)-down_matrix(i,:))*U+yy-z+bet*((1-up)*((1-dd).*...
            (S_sam(i)+lam1*alph_e*sum(max(S2_e(:,i)-S_sam(i),0))./nf))+...
            up*((1-dd).*...
            (S_sam(min(i+1,nx))+lam1*alph_e*sum(max(S2_e(:,min(i+1,nx))-S_sam(min(i+1,nx)),0))./nf)))-bet*((1-down)*lam0*alph_e*aS(i)+down*lam0*alph_e*aS(max(i-1,1)));
    end
    dis=sum(sum(abs(S_sam2-S_sam)));
    S_sam=S_sam2;
end
% now update the y: if surplus of propsed pair lied above indifference
% curve then reduce
yy=yy-abs(yy)*(S_sam(kk)-eps0)/((100));
dis2=abs(S_sam(kk)-eps0);
end
yy_0(qc,cas)=yy;
qc=qc+1;
end
cas=cas+1;
end


%%
figure(2)
close
hold on
h1=plot(dd_d(:,:,1),yy_d(:,:,1),'b','LineWidth',1.5)
h2=plot(dd_d(:,:,2),yy_d(:,:,2),'r','LineWidth',1.5)
h3=plot(d0grid,yy_0(:,1),'--b','LineWidth',1.5)
h4=plot(d0grid,yy_0(:,2),'--r','LineWidth',1.5)
leg1=legend([h1(1) h2(2) h3 h4 ], 'Worker ICs', 'Planner ICs','Worker Reservation','Planner Reservation','Location','NorthEast')
%leg1.NumColumns=2
legend('boxoff')
xh=xlabel('Job Security $\theta_{\delta}$','Interpreter','latex')
yh=ylabel('Job Productivity $\theta_{y}$','Interpreter','latex')
set([leg1],'fontweight','bold','fontsize',11);
set([xh,yh],'fontweight','bold','fontsize',15);
set(gca,'XDir','Reverse')
print -depsc2 ICs.eps 



