function [mom]=moments(stat, firm, hc, wage, espell, jspell, uspell,N,T,lam1,z,yn,x)

    % indicator for job-to-job movers
    jj_m=(lagmatrix(firm,1)~=firm & lagmatrix(stat,1)==1);
    layoff=(stat==0 & lagmatrix(stat,1)==1);
    jobfind=(stat==1 & lagmatrix(stat,1)==0);

    %% 1st Moment: jfr
    ue=lagmatrix(stat,1)==0;
    mom(1)=sum(jobfind(:))./sum(ue(:));
    clear jobfind ue
    
    %% 2nd Moment: Mean EE Rate: At a different Firm (employed)   
    stat_2=stat(1:end-1,:);
    stat_3=lagmatrix(stat,1);
    mom(2)=sum(jj_m(:))/sum(sum(stat_2==1))+lam1/(2*100); % assume that if you draw same firm move every other time (tie-break)
    
    %% 3-6th Mom: Separation rate at different tenure
    tmax=20;
    sept=zeros(1,tmax);
    for tt=1:tmax
    high_tt=logical(lagmatrix(espell,1)>(tt-1)*12 & lagmatrix(espell,1)<=(tt)*12);
    sept(tt)=sum(layoff(high_tt))/sum(stat_3(high_tt)==1);
    end
   
    sept=sept-sept(1);
   
    mom(3)=sum(layoff(:))/sum(sum(stat_3==1));
    mom(4)=sept(2);
    mom(5)=sept(5);
    mom(6)=sept(10);
    clear stat_2 stat_3 sept high_tt res1
    
    %% Mom 7: Skill Decay 
    
    % addtl wage variables
    whelp=wage;
    whelp(whelp==0)=nan;
    meanwage=repmat(nanmean(log(whelp),1),T,1); % mean of log wages while employed at the invidiaul level
    lw=log(wage(:))-meanwage(:);
    lwp=lw(isfinite(lw));
    
    % compute an indicator vector for unemployment exit
    id2=repmat(linspace(1,N,N),T,1);
    id=id2(:);
    ind=find(id==lagmatrix(id,1) & stat(:)-lagmatrix(stat(:),1)==1 & lagmatrix(uspell(:),1)<24);% same guy, just got hired

    %regress log wage of the newly hired on constant, their average log wage and duration of previous uspell
    b = regress(log(wage(ind)), [ones(size(meanwage(ind))) meanwage(ind) uspell(max(ind-1,1))]);
    mom(7)=b(3);
    
    clear ind uspell lw id2 id whelp
    %% Mom 8: Relation btw Pay and Layoff Risk
    % regress layoff indicators on demeaned log wages
  
    meansep=repmat(mean(layoff,1),T,1);
%    layoff_tm=lagmatrix(layoff,1);
%      b = regress(layoff_tm(stat==1),[ones(size(wage(stat==1))) meansep(stat==1) log(wage(stat==1)) meanwage(stat==1)]);
%      mom(8)=b(3);
     
    % Average Firm Level Churn
    ny=max(max(firm));
    firm_sep = ones(ny,1);
    for i=1:ny
        firm_sep(i,1)=mean(layoff(firm==i));
    end 
    firm_sep=firm_sep';
     
    % Regress mean separation rate of the employer on log wages
    b =regress(firm_sep(firm(stat==1))',[ones(size(wage(stat==1))) log(wage(stat==1)) meanwage(stat==1) meansep(stat==1)]);
    mom(13)=b(2);
    
    clear firm_sep layoff_tm meansep
    %%  Mom 9: Relative Wages of the Newly Hired
    mom(8)=1-mean(wage(espell==25 & stat==1))./mean(wage(wage>0));   

    %% Mom 10: 50-10 and 90-50 of Log Wages
  
    mom(9)=prctile(lwp(:),50)-prctile(lwp(:),10);
    mom(10)=prctile(lwp(:),90)-prctile(lwp(:),50);
  
    clear lwp
    %% Mom 12: Wage Growth for Continuosly Employed Workers
    lag=12;
    wg_ind=(lagmatrix(espell,lag)==espell-lag & repmat(linspace(1,T,T)',1,N)>lag & espell-lag>0);
    lwage=lagmatrix(wage,lag);
    wg_e=(wage(wg_ind)-lwage(wg_ind))./(wage(wg_ind));
    mom(11)= nanmean(wg_e);

    clear lwage wg_ind
   %% Mom 15 log wage upon move on duration of previous spell
    % see below for regression description
    TT=repmat(linspace(1,T,T)',1,N); 
    jj_lag = lagmatrix(jj_m, -1); %indicates whether jj move next period
    jj_lag = [jj_lag(1:end-1,:); zeros(1,N)];
    jj_lag_full=jj_lag.*(jspell<=TT); % jj move next period and job has not started before time 0
    jj_full=jj_m.*(lagmatrix(jspell,1)<=lagmatrix(TT,1)); %jj move this period and previous job has not started before time zero
    jj_ind = find(jj_full);
    jsp = jspell(logical(jj_lag_full));
    
    prev_wage_start = log(wage(jj_ind-jsp)); %first wage of job mover at previous job
    prejob_jten=jspell(jj_lag_full==1); % length of preious job
    
    %regress the new wage of someone who just moved on the first wage on
    %her previous job and the length of the previous job
    
    b = regress(log(wage(jj_ind)), [ones(size(prev_wage_start)) prev_wage_start prejob_jten]);
    xx=prejob_jten<96;
    lhs=log(wage(jj_ind));
    lhs(xx);
    rhs1=ones(size(prev_wage_start));
    b = regress(lhs(xx), [rhs1(xx) prev_wage_start(xx) prejob_jten(xx)]);
    mom(12)=b(3);
    
    
    mom(14)=mean(z)/(mean(yn(firm(stat==1)))+mean(x(hc(stat==1))));