function [Sxv2,w,WU,rs]= values_full_with_u(dn,yn,bet,lam0,lam1,alph,nx,nf,x,up,down,z,by1,by2,bd1,bd2,thet,ymin)


%% parameters
dis=10;
eps=10^-3;
parr = [lam0, lam1, alph, up,  down,  by1, by2, bd1, bd2, thet, ymin];
check=0;

%% Iterate on the Surplus for each firm worker match until convergence

S2=rand(nf,nx);
S02=S2;
U=rand(nx);
up_matrix=zeros(nx,nx);
down_matrix=zeros(nx,nx);
for i=1:nx
    if i==nx
        up_matrix(i,i)=1;
    else
        up_matrix(i,i)=1-up;
        up_matrix(i,i+1)=up;
    end
end
for i=1:nx
    if i==1
        down_matrix(i,i)=1;
    else
        down_matrix(i,i)=1-down;
        down_matrix(i,i-1)=down;
    end
end
inv_matrix=inv(eye(nx)-bet*down_matrix);
ct=0;
%'starting the fixed point hunt'
while (abs(dis)>eps) && (ct < 20000)
    aS=1/nf*(sum(S2)); %Avg Surplus for each skill type
    U=inv_matrix*(z+bet*down_matrix*lam0*alph*aS');
    for i=nx:-1:1
        S2(:,i)=x(i)+bet*(up_matrix(i,:)-down_matrix(i,:))*U+yn-z+bet*((1-up)*((1-dn).*...
            (S2(:,i)+lam1*alph*(sum(max(repmat(S2(:,i)',nf,1)-repmat(S2(:,i),1,nf),0),2))./nf))+...
            up*((1-dn).*...
            (S2(:,min(i+1,nx))+lam1*alph*(sum(max(repmat(S2(:,min(i+1,nx))',nf,1)-repmat(S2(:,min(i+1,nx)),1,nf),0),2))./nf)))-bet*((1-down)*lam0*alph*aS(i)+down*lam0*alph*aS(max(i-1,1)));
    end
    
    S2=max(S2,0);
    dis=sum(sum(abs(S2-S02)));
    S02=S2;
    ct = ct +1;
    
end

if ct == 20000
    warning('Failed to converge!')
    parr
end

%ct

% % Reshapes stuff
for hc=1:nx
    %  Sx=S(:,:,hc);
    Sxv2(:,hc)=S2(:,hc);
    [Sxv(:,hc),IX(:,hc)]=sort(Sxv2(:,hc));
end


%% Compute W-U depending on the negotiation benchmark
for hc=1:nx
    for i=1:nf
        for j=1:nf+1
            if j==1
                WU(i,j,hc)=alph*Sxv2(i,hc);
                J0(i,j,hc)=(Sxv2(i,hc)-WU(i,j,hc));
            else
                WU(i,j,hc)=(Sxv2(j-1,hc)+alph*(Sxv2(i,hc)-Sxv2(j-1,hc)))*(Sxv2(i,hc)>=Sxv2(j-1,hc));
                J0(i,j,hc)=(Sxv2(i,hc)-WU(i,j,hc))*(Sxv2(i,hc)>=Sxv2(j-1,hc));
            end
        end
    end
end

%wage for highest hc (can directly solve)
for i=1:nf
    for j=1:nf+1
        move=Sxv2(:,nx)>Sxv2(i,nx);
        reneg=WU(i,j,nx)<Sxv2(:,nx) & Sxv2(:,nx)<=Sxv2(i,nx);
        wtop(i,j)=x(nx)+yn(i)-J0(i,j,nx)*(1-bet*(1-dn(i))*(1-lam1*1/nf*(sum(reneg)+sum(move))))+bet*(1-dn(i))*lam1*1/nf*J0(i,2:end,nx)*reneg;
        if j>1
            wtop(i,j)=wtop(i,j).*(Sxv2(i,nx)>=Sxv2(j-1,nx));
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% J generally depends on both current and benchmark human capital, for now
% only know value at hire (from surplus splitting rules)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
for hcneg=1:nx
    for hc=hcneg:nx
        J(:,:,hc,hcneg)=J0(:,:,hcneg);
    end
end

%% Algorithm to solve for wages from here:
% 1) Fix firm i,benchmark firm j, and human capital at negotiation hcneg. This is when the wage is set.
% We will find the wage for each combination completely separately
% 2) We do not know the renegotiation set M2. Fix the reneg set at all higher levels of human capital hc>hcneg
% at the reneg set for [hc] which is simply all firms with surplus less equal i and more than j.
% 3) Directly compute the wage that delivers the value. Do this by
% substituting out all the unknown values J for higher levels of hc such
% that you cet an expression that only depends on the wage and known values
% J
% 4) Then check the sets as follows. Given the wage, go up from hc+1, and
% check for each level of human capital whether the set M2 is actually even
% larger then previously assume. If so, expand it for this and all levels
% thereafter, Then go back to 3 and recompute the wage directly, then
% update sets again, until done.

firmgrid=linspace(1,nf,nf);
gam=up/(1-up);

reneg_set=zeros(nf,nf+1,nx-1,nx,nf);

for i=1:nf %(employer)
    for hcneg=1:nx-1 %human capital at last negotiation
        for j=[1 1+firmgrid(Sxv2(:,hcneg)<=Sxv2(i,hcneg))] %% just compute wage for relevant benchmarks (unemployment and firms with lower surplus)
            
            move=Sxv2(:,hcneg)>Sxv2(i,hcneg);
            pmove=sum(move);
            
            % initial guess: for all levels of human capital above, rebargain at the
            % same set M2
            reneg_all=zeros(nf,nx);
            
            for hc=hcneg:nx
                %reneg_all(:,hc)=((S2(i,hc)+U(hc)-J(i,2:end,hc,hc)')>=S2(i,hc)+U(hc)-(x(hc)-x(hcneg)+J(i,j,hc,hc)') & Sxv2(:,hc)<=Sxv2(i,hc));
                reneg_all(:,hc)=WU(i,j,hcneg)<Sxv2(:,hcneg) & Sxv2(:,hcneg)<=Sxv2(i,hcneg);
            end
            
            % build objects
            eps2=3;
            it=0;
            reneg_old=0;
            
            while eps2>0
                
                
                bett=bet*(1-dn(i));
                Bmat=bett*(1-up);
                vs=nx-hcneg;
                Jmat=zeros(1,vs);
                Pmat=zeros(1,vs);
                nu2=ones(1,vs);
                nu3=ones(1,vs);
                eta=ones(1,vs);
                xtr=ones(1,vs);
                Emat=ones(1,vs);
                
                for hc=hcneg:nx
                    ind=hc-hcneg+1;
                    Jmat(ind)=lam1*1/nf*(squeeze(J(i,2:end,hc,hc))*reneg_all(:,hc));
                    Pmat(ind)=x(hc)+yn(i);
                    nu2(ind)=bett*(1-up)*(1-lam1/nf*(sum(reneg_all(:,hc))));
                    nu3(ind)=bett*(1-up)*(1-lam1/nf*(sum(reneg_all(:,hc))+pmove));
                    if ind>1
                        eta(ind)=gam*nu3(ind)/(1-nu3(ind));
                        xtr(ind)=eta(ind)/gam;
                        if hc<nx
                            Emat(ind)=Emat(ind-1)*(eta(ind));
                            if ind==2
                                Bmat(ind)=bett*up/(1-nu3(ind));
                            else
                                Bmat(ind)=bett*up/(1-nu3(ind))*prod(eta(2:ind-1));
                            end
                        elseif hc==nx
                            Emat(ind)=Emat(ind-1)*gam*nu3(ind)/(1-nu3(ind)/(1-up));
                            Bmat(ind)=bett*up/(1-nu3(ind)/(1-up))*prod(eta(2:ind-1));
                        end
                    end
                end
                
                w(i,j,hcneg)=1/(sum(Emat))*(-(1-nu3(1)).*J(i,j,hcneg,hcneg)+Emat*Pmat'+Bmat*Jmat');
                
                % compute firm values at higher human capital given current wage
                
                %in order to compute J(i,j,hc,hcneg) for hc>hcneg now that we know the
                %wage, need to recompute the Emat and Bmat for each hc>hcneg. but these are
                %easy because all the pieces already exist
                
                for hc=hcneg+1:nx-1 % for each level of skill above
                    ind=hc-hcneg+1;
                    Emat=1;
                    Bmat=bett*(1-up);
                    for yy=hc+1:nx
                        ind2=yy-hc-1+ind;
                        ind3=yy-hc+1;
                        if yy<nx
                            Emat(ind3)=Emat(ind3-1)*(eta(ind2));
                            if ind3==2
                                Bmat(ind3)=bett*up/(1-nu3(ind2));
                            else
                                Bmat(ind3)=bett*up/(1-nu3(ind2))*prod(eta(2:ind3-1));
                            end
                        elseif yy==nx
                            Emat(ind3)=Emat(ind3-1)*gam*nu3(ind2)/(1-nu3(ind2)/(1-up));
                            Bmat(ind3)=bett*up/(1-nu3(ind2)/(1-up))*prod(eta(2:ind2-1));
                        end
                    end
                    J(i,j,hc,hcneg)=1/(1-nu3(ind))*(Emat*(Pmat(ind:end)-w(i,j,hcneg))'+Bmat*Jmat(ind:end)');
                    reneg_all(:,hc)=[(S2(i,hc)+U(hc)-J(i,2:end,hc,hc)')>(S2(i,hc)+U(hc)-J(i,j,hc,hcneg)')& Sxv2(:,hc)<=Sxv2(i,hc)];
                end
                J(i,j,end,hcneg)=(-w(i,j,hcneg)+Pmat(end)+bett*Jmat(end))/(1-nu3(end)/(1-up));
                reneg_all(:,end)=[(S2(i,end)+U(end)-J(i,2:end,end,end)')>(S2(i,end)+U(end)-J(i,j,end,hcneg)')& Sxv2(:,end)<=Sxv2(i,end)];
                eps2=abs(sum(sum(reneg_old-reneg_all)));
                reneg_old=reneg_all;
                eps2=eps2*(1-(it>7)); % in rare cases the renegotiation set oscillates as we iterate. I have verified that this is always reached within 7 iterations and results in very minor imprecesion. The next block can be turned on to verify this
%                 if it>7
%                     xxx=[xxx wold/w(i,j,hcneg)-1];
%                 end
%                 reneg_all;
%                 wold=w(i,j,hcneg);

                             it=it+1;
            end
            reneg_set(i,j,hcneg,:,:)=reneg_all'; % this stores, for each level of benchmark human capital and current employer and benchmark firm, for all higher levels of human capital, the associated firms that lead to renegotiation at the current employer
        end
    end
end

for i=1:nf
    reneg_set(i,1,nx,:,:)=[zeros(nf,nx-1) ones(nf,1).*(Sxv2(:,nx)<=Sxv2(i,nx))]'  ;
    for j=2:nf+1
        reneg_set(i,j,nx,:,:)=[zeros(nf,nx-1) Sxv2(:,nx)>Sxv2(j-1,nx)&Sxv2(:,nx)<=Sxv2(i,nx)]'  ;
    end
end

rs=sparse(logical(reneg_set(:)));
w(:,:,nx)=wtop;

