* File of the Project "670" - 52_deltas.do
* Content: the only exercise thats reported in the manuscript in this file is the "exercise two" below where I compute the residualized firm level unemployment risk 
* (which corresponds to the first exercise in the file 5_1) and then measure how that changes upon a job-to-job move (this is reported in section 3.5, second exercise)

clear

cap log close
log using "$log/53_firm_level_jobrisk.log", replace

set more off

*************************************************************
* do workers reduce firm level ue risk through jj-moves?
****************************************************************

use "$data/monthly_2.dta", clear

set seed 123456789

bys persnr: gen sample=runiform() if _n==1
bys persnr: egen sample2=max(sample)
count
keep if sample2<.5
count
drop sample sample2

quietly{
// leave-out1: drop origin observations for movers
bys betnr persnr: egen hoy=max(jobtojob)
sum hoy
replace jobloss_ue=.n if hoy==1

tsset persnr caldate
sort persnr caldate

// leave-out2: drop destination observations for movers
gen jj_yest=L.jobtojob
bys betnr persnr: egen hoy2=max(jj_yest)
sum hoy2
replace jobloss_ue=.n if hoy2==1
drop hoy* 

// exercise one: average residual at firm level
reghdfe jobloss_ue if emp==1, a(persnr calyr) res(resi_ue)
bys betnr: egen m_resi_ue=mean(resi_ue)

sort persnr caldate

noi sum m_resi_ue if jobtojob==1, det
noi sum m_resi_ue if L.jobtojob==1, det

gen riskchange=m_resi_ue[_n+1]-m_resi_ue[_n] if jobtojob==1
noi sum riskch*, det
drop riskch*

//exercise two: average firm level
reghdfe jobloss_ue  if emp==1, a(betnr) res(res_del_ue)
gen chi_ue=jobloss_ue-res_del_ue
bys betnr: egen chi_ue2=mean(resi_ue)

sort persnr caldate

noi sum chi_ue2 if jobtojob==1, det
noi sum chi_ue2 if L.jobtojob==1, det

gen riskchange=chi_ue2[_n+1]-chi_ue2[_n] if jobtojob==1
noi sum riskch*, det
}
